summaryrefslogtreecommitdiff
path: root/find-deprecated-pkgs
diff options
context:
space:
mode:
Diffstat (limited to 'find-deprecated-pkgs')
-rwxr-xr-xfind-deprecated-pkgs56
1 files changed, 37 insertions, 19 deletions
diff --git a/find-deprecated-pkgs b/find-deprecated-pkgs
index a527d2c..de7bb36 100755
--- a/find-deprecated-pkgs
+++ b/find-deprecated-pkgs
@@ -9,46 +9,50 @@ set -e
repos="core extra community"
repos_x86_64="$repos testing multilib multilib-testing"
repos_i686="$repos testing build-support"
-repos_armv7h="$repos alarm"
+repos_armv7h="$repos alarm" # although we don't sync [alarm] we blacklist its packages to conflict with your-freedom
# Parabola repos for checking blacklists like your-privacy,
# which sometimes block [libre] and [pcr] packages.
# [nonprism] and [nonsystemd] are not listened because
-# we do not blacklists those packages
+# we do not blacklists those packages anywhere
repos_parabola="pcr pcr-multilib pcr-multilib-testing pcr-testing libre libre-multilib libre-multilib-testing libre-testing"
# Set the blacklist files
# aur-blacklist.txt is not here since we want to check Arch's official repos
blacklists="blacklist.txt"
-# List here files that may also blacklist Parabola packages
+
+# List here files that may also blacklist Parabola packages.
+# These are intended to be used with $repos_parabola
blacklists_parabola="your-initfreedom-blacklist.txt your-privacy-blacklist.txt your-freedom_emu-blacklist.txt"
# Mirrors. Please choose HTTPS over HTTP when possible
-# x86_64 mirror
+# x86_64 mirrors
for r in $repos_x86_64; do
mirrors+=(https://mirrors.edge.kernel.org/archlinux/$r/os/x86_64/)
done
-# i686 mirror
+# i686 mirrors
for r in $repos_i686; do
mirrors+=(https://mirror.archlinux32.org/i686/$r/)
done
-# armv7h mirror
+# armv7h mirrors
for r in $repos_armv7h; do
mirrors+=(https://fl.us.mirror.archlinuxarm.org/armv7h/$r/)
done
# Parabola mirrors, used to check [libre] and [pcr] packages
-if [[ $1 = parabola ]]; then
+for r in $1 $2; do
+if [[ $r = parabola ]]; then
for r in $repos_parabola; do
mirrors+=(https://mirror.grapentin.org/parabola/$r/os/x86_64/)
mirrors+=(https://mirror.grapentin.org/parabola/$r/os/i686/)
mirrors+=(https://mirror.grapentin.org/parabola/$r/os/armv7h/)
done
fi
+done
-# Sed expresion tested on Nginx, change if needed
+# Sed expresion tested for Nginx, change if needed
sedexp='s/.*href="//;s/\-any.pkg.tar.xz.*//;s/\-x86_64.pkg.tar.xz.*//;s/\-i686.pkg.tar.xz.*//;s/\-armv7h.pkg.tar.xz.*//'
-# extra sedexps for symbols
+# extra sedexps for special characters/symbols
sedexp+=';s/%2B/+/g;s/%3A/:/g;s/%40/@/g'
usage() {
@@ -79,42 +83,56 @@ mkpkglist() {
parabola_pkgs=$(mktemp)
arch_pkgs=$(mktemp)
case $1 in
- parabola) curl -s ${mirrors[@]} | grep '".*.pkg.tar.xz"' | sed $sedexp > $parabola_pkgs
+ parabola) curl -s ${mirrors[@]} | grep '".*.pkg.tar.xz"' | sed $sedexp |
+ for f in $(cat /dev/stdin); do echo ${f%-*-*} >> $parabola_pkgs; done
;;
- arch) curl -s ${mirrors[@]} | grep '".*.pkg.tar.xz"' | sed $sedexp > $arch_pkgs
+ arch) curl -s ${mirrors[@]} | grep '".*.pkg.tar.xz"' | sed $sedexp |
+ for f in $(cat /dev/stdin); do echo ${f%-*-*} >> $arch_pkgs; done
;;
esac
}
err() {
- printf '%sError:%s %s\n' \
+ printf '%s==> Error:%s %s\n' \
"$(tput setaf 1)" \
"$(tput sgr0)" \
"$1"
false
}
+msg() {
+ printf '%s==>%s %s\n' \
+ "$(tput bold)" \
+ "$(tput sgr0)" \
+ "$1"
+}
+
check(){
mkpkglist $1
case $1 in
- parabola) pkgs=$(cut -d ":" -f 1 $blacklists_parabola | grep -v ^#)
+ parabola) msg 'Comparing blacklists with Parabola packages ...'
+ pkgs=$(cut -d ":" -f 1 $blacklists_parabola | grep -v ^#)
for p in $pkgs; do
- grep ^$p $parabola_pkgs &> /dev/null || printf '%s was not found\n' "$p"
+ grep -xw ^$p $parabola_pkgs &> /dev/null || printf '%s was not found\n' "$p"
done
+ msg 'done'
;;
- arch) pkgs=$(cut -d ":" -f 1 $blacklists | grep -v ^#)
+ arch) msg 'Comparing blacklists with Arch packages ...'
+ pkgs=$(cut -d ":" -f 1 $blacklists | grep -v ^#)
for p in $pkgs; do
- grep ^$p $arch_pkgs &> /dev/null || printf '%s was not found\n' "$p"
+ grep -xw ^$p $arch_pkgs &> /dev/null || printf '%s was not found\n' "$p"
done
+ msg 'done'
;;
*) err "$1 is not a valid argument"
;;
esac
}
-if [ -s $1 ]; then
+if [[ -s $@ ]]; then
usage
else
- ping -q -w 1 -c 1 `ip r | grep ^default | awk '{print $3}'` &> /dev/null || err 'You must have internet connection to run this program'
- check $1 || STATUS=$? usage
+ ip r | grep ^default | awk '{print $3}' |
+ ping -q -w 1 -c 1 $(tail -n1 /dev/stdin) &> /dev/null || err 'You must have internet connection to run this program'
+ for arg in $@; do check $arg; done
fi